// MCell User DLL template for Margolus neighborhood
//
// Borland Delphi v.2.0 and above

library TemplateMG;  // Your DLL name, change by "Save Project as..." option of the File menu

uses
  SysUtils, Classes;

//
// Calculate the new state of the 'Me' cell.
procedure CARuleMG(Generation, col, row: Integer;
                   var ul, ur, ll, lr: Integer); stdcall;
var
  iTmp: Integer;
begin
  // perform any rule here
  if (Generation mod 2) = 1 then // odd pass
  begin
    iTmp := ul; ul := lr; lr := iTmp;
  end
  else // even pass
  begin
    iTmp := ur; ur := ll; ll := iTmp;
  end;
end;
//
// Setup the rule.
// The function is called immediatelly after this rule is selected in MCell.
procedure CASetup(var RuleType, CountOfColors: Integer; ColorPalette, Misc: PChar); stdcall;
begin
  RuleType := 3;       // 1 - 1D, 2 - 2D, 3 - Margolus
  CountOfColors := 16;  // count of states, 0..n-1
  StrCopy(ColorPalette, '');  // optional color palette specification
  StrCopy(Misc, '');   // optional extra parameters
end;

exports
  CARuleMG index 1,
  CASetup  index 2;

begin
  // optional internal initialization.
end.
